package Person.person;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import javax.swing.*;

public class PersonView extends JFrame
{
   private static final long serialVersionUID = 1L;

   // Label-Feld fr die Ausgabe einer Message nach der Ausfhrung von Actions
   private JLabel jlblMessage;
   private JPanel jpNorth;
   private JPanel jpCenter;
   private JPanel jpSouth;

   private JTextField tfNachname;
   private JTextField tfVorname;
   private JTextField tfAlter;
   private JTextField tfWohnort;
   private JTextField tfEinkommen;
   private JLabel lblNachname;
   private JLabel lblVorname;
   private JLabel lblAlter;
   private JLabel lblWohnort;
   private JLabel lblEinkommen;
   private JButton jbSave;
   private JButton jbShow;
   private JButton jbLogView;
   private JButton jbLogModel;
   private JButton jbExit;
   

   // ---------------------------------------------------------------------------

   // Constructor
   public PersonView()
   {
      super("Erfassung von PersonView-Daten");
      this.initPersonView();
      this.setVisible(true);
   }

   // getter und setter der Felder
   public  String getTfNachname() { return this.tfNachname.getText(); }
   public  String getTfVorname() { return this.tfVorname.getText(); }
   public  String getTfAlter() { return this.tfAlter.getText(); }
   public  String getTfWohnort() { return this.tfWohnort.getText(); }
   public  String getTfEinkommen() { return this.tfEinkommen.getText(); }
      
   public  void setTfNachname(String p_TfNachname) { this.tfNachname.setText(p_TfNachname); }
   public  void setTfVorname(String p_TfVorname) { this.tfVorname.setText(p_TfVorname); }
   public  void setTfAlter(String p_TfAlter) { this.tfAlter.setText(p_TfAlter); }
   public  void setTfWohnort(String p_TfWohnort) { this.tfWohnort.setText(p_TfWohnort); }
   public  void setTfEinkommen(String p_TfEinkommen) { this.tfEinkommen.setText(p_TfEinkommen); }
   

   // Initialisierung der View
   private void initPersonView()
   {
      // Layout des Frames
      this.setLayout(new BorderLayout(50,50));
      this.setSize(800, 600);
      this.setLocation(400, 200);
      this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   
      // Aufbau der Panels
      this.jpNorth  = this.initNorthPanel();
      this.jpCenter = this.initCenterPanel();
      this.jpSouth  = this.initSouthPanel();
   
      // Eintrag der Panels im Frame 
      this.add(BorderLayout.NORTH,  jpNorth ); 
      this.add(BorderLayout.CENTER, jpCenter); 
      this.add(BorderLayout.SOUTH,  jpSouth );
   }

   // Initialisierung des Headpanels mit den Keyfeldern (primarykey) und Commands 
   private JPanel initNorthPanel()
   {
      JPanel jpHead = new JPanel();
      jpHead.setLayout(new FlowLayout(FlowLayout.CENTER, 100, 10));
   
      // Kopfleiste ?
   
      return jpHead;
   }

   // Initialisierung der Datenfelder und Labelfelder
   private JPanel initCenterPanel()
   {
      JPanel jpCenter = new JPanel();
   
      this.initDataFields();
   	    
      jpCenter.setLayout(new GridLayout(1, 2, 100, 0));
      jpCenter.add(this.initLabelPanel());
      jpCenter.add(this.initDataPanel());
   
      return jpCenter;
   }
   
   protected JPanel initLabelPanel()
   {
      JPanel jpLabelPanel = new JPanel();
      jpLabelPanel.setLayout(new GridLayout(0,1));
   
      jpLabelPanel.add(lblNachname);
      jpLabelPanel.add(lblVorname);
      jpLabelPanel.add(lblAlter);
      jpLabelPanel.add(lblWohnort);
      jpLabelPanel.add(lblEinkommen);
         
      return jpLabelPanel;
   }
   
   protected JPanel initDataPanel()
   {
      JPanel jpDataPanel = new JPanel();
      jpDataPanel.setLayout(new GridLayout(0,1));
   
      jpDataPanel.add(tfNachname);
      jpDataPanel.add(tfVorname);
      jpDataPanel.add(tfAlter);
      jpDataPanel.add(tfWohnort);
      jpDataPanel.add(tfEinkommen);
         
      return jpDataPanel;
   }
   
   protected void initDataFields()
   {
      this.tfNachname  = new JTextField(10);
      this.tfVorname  = new JTextField(10);
      this.tfAlter  = new JTextField(10);
      this.tfWohnort  = new JTextField(10);
      this.tfEinkommen  = new JTextField(10);
      this.lblNachname = new JLabel("LblNachname: " );
      this.lblVorname = new JLabel("LblVorname: " );
      this.lblAlter = new JLabel("LblAlter: " );
      this.lblWohnort = new JLabel("LblWohnort: " );
      this.lblEinkommen = new JLabel("LblEinkommen: " );
   }

   // Initialisierung des Southpanels mit den Commands 
   protected JPanel initSouthPanel () 
   {
      JPanel jpCommands = new JPanel();
      jpCommands.setLayout(new GridLayout(2, 3, 50, 10));
   
      this.jbSave  = new JButton("JBSAVE");
      jpCommands.add(this.jbSave );
      this.jbShow  = new JButton("JBSHOW");
      jpCommands.add(this.jbShow );
      this.jbLogView  = new JButton("JBLOGVIEW");
      jpCommands.add(this.jbLogView );
      this.jbLogModel  = new JButton("JBLOGMODEL");
      jpCommands.add(this.jbLogModel );
      this.jbExit  = new JButton("JBEXIT");
      jpCommands.add(this.jbExit );
   
      // Message-Panel fr die Ausgabe einer Message nach Actions
      JPanel jpMessage = new JPanel();
      jpMessage.setLayout(new GridLayout(1,1));
      this.jlblMessage  = new JLabel("");
      jpMessage.add(this.jlblMessage );
   
      JPanel jpActions = new JPanel();
      jpActions.setLayout(new GridLayout(2, 1, 10, 10 ));
      jpActions.add(jpCommands);
      jpActions.add(jpMessage);
      	
      return jpActions;
   }

   public void reset()
   {   
      this.tfNachname.setText("tfNachname");
      this.tfVorname.setText("tfVorname");
      this.tfAlter.setText("tfAlter");
      this.tfWohnort.setText("tfWohnort");
      this.tfEinkommen.setText("tfEinkommen");
      this.lblNachname.setText("lblNachname");
      this.lblVorname.setText("lblVorname");
      this.lblAlter.setText("lblAlter");
      this.lblWohnort.setText("lblWohnort");
      this.lblEinkommen.setText("lblEinkommen");
      this.jbSave.setText("jbSave");
      this.jbShow.setText("jbShow");
      this.jbLogView.setText("jbLogView");
      this.jbLogModel.setText("jbLogModel");
      this.jbExit.setText("jbExit");
   }

   // jlblMessage ist ein Attribut, das nicht aus dem Modell kommt
   protected void setMessage (String  p_value ) { this.jlblMessage.setText( p_value ); }

   // getter fr die Commands (Button gedrckt?)
   public JButton getjbSave () { return this.jbSave; }
   public JButton getjbShow () { return this.jbShow; }
   public JButton getjbLogView () { return this.jbLogView; }
   public JButton getjbLogModel () { return this.jbLogModel; }
   public JButton getjbExit () { return this.jbExit; }
   
   // Registrieren der Buttons beim ActionListener.
   public void setjbSaveListener(ActionListener al) { this.jbSave.addActionListener(al); }
   public void setjbShowListener(ActionListener al) { this.jbShow.addActionListener(al); }
   public void setjbLogViewListener(ActionListener al) { this.jbLogView.addActionListener(al); }
   public void setjbLogModelListener(ActionListener al) { this.jbLogModel.addActionListener(al); }
   public void setjbExitListener(ActionListener al) { this.jbExit.addActionListener(al); }
   
}
